chiark / gitweb /
dot/bash_profile: Reorder PATH /usr/local before /usr before /.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
82c688c7 13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
b0d8acbe 136 vimrc mg zile
30169591 137 ditz-config
b3468c3b 138 mailrc signature
ce178f96 139 cgrc tigrc
e7d23024 140 gdbinit
8a7e906d 141 guile
1d89ce86 142 rcrc
5d25e440 143 toprc
a6a6806a 144 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
cbffcf2b 145 aspell.conf
78719982 146 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
147 lisp-init.lisp:.cmucl-init.lisp
148 lisp-init.lisp:.sbclrc
149 lisp-init.lisp:.clisprc.lisp
f6335a0c 150 lisp-init.lisp:.eclrc
b5bf3445 151 swank.lisp
2425eca9 152 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 153[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 154 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 155 fonts.conf
e517857c 156 stalonetrayrc
1c6b19d4 157 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 158 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 159 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 160 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 161 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 162 e16-bindings:.e16/bindings.cfg"
f617db13
MW
163echo "Installing dotfiles..."
164for d in $dotfiles; do
739bccbf
MW
165 target=.$d
166 case $d in
167 *:*) target=${d#*:} d=${d%%:*};;
168 esac
169 ft=$HOME$sub/$target
170 dir=${ft%/*}
171 mkdir -p $dir
99063107 172 ln -s $here/dot/$d $ft.new
739bccbf
MW
173 mv $ft.new $ft
174 echo " $target"
f617db13 175done
852cd5fb 176echo " all done."
f617db13 177
403dc178
MW
178## Substitute things which need substituting.
179dotfilessubst="
180 gitconfig
181 pulse-default.pa.in:.pulse/default.pa"
182echo "Installing dotfiles with substitutions..."
183for d in $dotfilessubst; do
184 case $d in
185 *:*) target=${d#*:} d=${d%%:*};;
186 *) target=.$d d=$d.in;;
187 esac
188 ft=$HOME$sub/$target
189 dir=${ft%/*}
190 mkdir -p $dir
191 sed "
2b5d4580
MW
1921i\\
193### generated by $here/setup; do not edit!\\
403dc178
MW
194
195/@home@/ s\a\a$HOME\ag
73165cde 196/@profile@/ s\a\a$here\ag
403dc178 197/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
403dc178
MW
198" dot/$d >$ft.new
199 mv $ft.new $ft
200 echo " $target"
201done
202echo " all done."
203
f4e43257 204## Symlink backgrounds.
960af1a5
MW
205backgrounds="
206 jue-peek.jpg
207 medusa.jpg
5236501e 208 bsg-supper.jpg
960af1a5 209 rayne.jpg
56c871ef 210 hypatia.jpg
e1ca556b
MW
211 noodly.jpg
212 lovelace.jpg"
f4e43257
MW
213if [ "$xstuff" ]; then
214 echo "Installing backgrounds..."
215 for b in $backgrounds; do
216 for e in enlightenment e16; do
217 dir=$HOME$sub/.$e/backgrounds
218 t=$dir/$b
219 mkdir -p $dir
99063107 220 ln -s $here/bg/$b $t.new
f4e43257
MW
221 mv $t.new $t
222 done
223 echo " $b"
224 done
225 echo " all done."
226fi
227
ce178f96
MW
228###--------------------------------------------------------------------------
229### Install useful scripts included in this package.
230
e04c4857 231scripts="
547fb8af 232 mdw-editor
b20bfd83 233 mdw-pager
b056f5c4 234 mdw-conf
7ee12623 235 mdw-build
c4e84cb1 236 emacsclient-hack
8e08f814 237 movemail-hack
aaa2d943 238 sendmail-hack
68b2e9e6 239 aspell-hack
285a1386
MW
240 emerge-hack
241 lesspipe.sh
242 start-ssh-agent
4cdeb0d0
MW
243 svnwrap
244 hyperspec"
8e08f814 245[ "$xstuff" ] && scripts="$scripts
3bdada49 246 xinitcmd
34a5ea4e 247 un-backslashify-selection
c02999e8 248 lock-screen
8e08f814 249 xshutdown"
e04c4857
MW
250echo "Installing scripts..."
251mkdir -p $HOME$sub/bin
252for s in $scripts; do
253 ft=$HOME$sub/bin/$s
99063107 254 ln -s $here/bin/$s $ft.new
e04c4857
MW
255 mv $ft.new $ft
256 echo " $s"
257done
258echo " all done."
259
4d7d040b
MW
260hacks="
261 ssh:ssh"
262echo "Installing hacks..."
263for h in $hacks; do
264 d=${h%%:*} h=${h#*:}
265 ft=$HOME$sub/bin/hacks/$d
266 mkdir -p $ft
267 ln -s $here/hacks/$h $ft/$h.new
268 mv $ft/$h.new $ft/$h
269 echo " $d:$h"
270done
271echo " all done."
272
ce178f96
MW
273###--------------------------------------------------------------------------
274### Set up the Emacs config.
275
65ff0e8c
MW
276$echon "Finding a suitable emacs:$echoc"
277emacs=no
5fe24792 278for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
279 if type -p >/dev/null $i; then
280 emacs=$i
281 break
282 fi
283done
284if [ $emacs = no ]; then
285 echo " failed."
286 emacs=:
287else
288 echo " $emacs."
289fi
290
f617db13 291echo "Installing Emacs packages..."
400223a1
MW
292emacspkg="
293 make-regexp
a1293ade 294 ew-hols
a3bdb4d9 295 mdw-gnus-patch
1778b496 296 git git-blame vc-git stgit
400223a1
MW
297 quilt"
298for elib in $emacspkg; do
f617db13 299 $echon " $elib:$echoc"
65ff0e8c 300 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 301 (progn
852cd5fb
MW
302 (setq load-path (nconc load-path (list "~/lib/emacs")))
303 (kill-emacs (condition-case nil
304 (progn (load-library "'"$elib"'") 0)
20eb0692 305 (error 1))))'; then
f617db13
MW
306 echo " already installed."
307 else
99063107
MW
308 if [ -f el/$elib.el ]; then
309 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
310 else
311 $echon " downloading$echoc"
312 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
313 fi
f617db13
MW
314 $echon " compiling$echoc"
315 (cd $HOME$sub/lib/emacs;
65ff0e8c 316 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 317 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
318 echo " done."
319 fi
320done
852cd5fb 321echo " all done."
f617db13
MW
322
323$echon "Setting up Emacs configuration:$echoc"
324$echon " linking$echoc"
99063107 325for f in dot-emacs.el Makefile; do
f617db13 326 set -- $(echo $link | tr : ' ')
99063107
MW
327 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
328 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
329done
330$echon " compiling$echoc"
c39d1139 331{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 332echo " done."
ce178f96
MW
333
334###----- That's all, folks --------------------------------------------------